//********************** 609drv_test.c *************************
//* This program is a test program for the S609 Frame Grabber
//* loadable Linux device driver. It covers the test for
//* the General IO access and the CrossPoint Switch control.
//*
//* Autor:		Charlie X. Liu
//*
//* Rev:		0.0	03/19/03	initial
//*
//* Copyright (C) 2003.	Sensoray Co., Inc.
//*
//**************************************************************
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA 02111-1307, USA

****************************************************************/

#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/types.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "s609drv.h"

int main(int argc, char **argv)
{
  char *device_name;
  int fd; int i;
  char ch[20];
  DWORD data;
  static WORD vin, vout;
  struct ioparam request;

  /** open device **/
  device_name = "/dev/s609";
  if((fd = open(device_name, O_RDWR)) < 0) {
    perror("s609drv open");
    return -1;
  }

#if 0
   /** read reg with RegRD **/
   for (i=0; i<(0x124/4); i++) {
	request.param2 = i*4;
	//fprintf(stderr, "reg addr = 0x%x\n", request.param2);
	//fprintf(stderr, "RegRD = 0x%x\n", RegRD);
	if(ioctl(fd, RegRD, &request)<0) {
	   perror("ioctl(RegRD)");
	   return -1;
	}
	data = request.param1;
	fprintf(stderr, "reg 0x%x = 0x%x", i*4, data);
	getchar();	//fprintf(stderr, "\n");
   }
#endif
      
   /** read GPIO with RegRD **/
   printf ("\nenter any key to start read GPIO wiht RegRD: ");
   getchar();
   request.param2 = GPIO_DATA;
   for (i=0; i<100; i++) {
	if(ioctl(fd, RegRD, &request)<0) {
	   perror("ioctl(RegRD)");
	   return -1;
	}
	data = request.param1;
	fprintf(stderr, "general IO input = %x 			Continue? ", data);
	scanf ("%s", ch);
	//if (!strcmp(ch,"q")) break;
	if (!strcmp(ch,"q")||!strcmp(ch,"n")) break;
   }

   fflush(stdin);

   /** read DIO with DioRD **/
   printf ("\nenter any key to start read DIO wiht DioRD: ");
   fflush(stdout);
   getchar();
   getchar();
   for (i=0; i<100; i++) {
	if(ioctl(fd, DioRD, &request)<0) {
	   perror("ioctl(DioRD)");
	   return -1;
	}
	data = request.param1;
	fprintf(stderr, "digital IO input = %x 				Continue? ", data);
	scanf ("%s", ch);
	if (!strcmp(ch,"q")||!strcmp(ch,"n")) break;
   }

   /** write DIO with DioWR **/
   printf ("\nenter any key to start write DIO wiht DioWR: ");
   fflush(stdout);
   getchar();
   getchar();
   request.param1 = 0x5555;
   for (i=0; i<100; i++) {
   request.param1 = (WORD)(~(request.param1));
	if(ioctl(fd, DioWR, &request)<0) {
	   perror("ioctl(DioWR)");
	   return -1;
	}
	fprintf(stderr, "digital IO output = %x 			Continue? ", request.param1);
	scanf ("%s", ch);
	if (!strcmp(ch,"q")||!strcmp(ch,"n")) break;
   }

   /** switch video channel ( v-in# -> v-out# ) with XptSW **/
   printf ("\nenter any key to start switching video channel wiht XptSW: ");
   fflush(stdout);
   getchar();
   getchar();
   for (i=0; i<100; i++) {
        do {
		printf("	enter video input channel # (1-16) : ");
		fflush(stdout);
		scanf ("%d", &vin);
        } while ( vin<1 || vin>16 );
        request.param1 = vin;	// v-in#
        do {
		printf("	enter video output channel # (1-8) : ");
		fflush(stdout);
		scanf ("%d", &vout);
        } while ( vout<1 || vout>8 );
        request.param2 = vout;	// v-out#

	if(ioctl(fd, XptSW, &request)<0) {
	   perror("ioctl(DioWR)");
	   return -1;
	}
	fprintf(stderr, "	V-input channel # %d --> V-output channel # %d	( in %d -> out %d )\n", 
						vin, vout, request.param1, request.param2 );
	fprintf(stderr, "Continue? ");
	scanf ("%s", ch);
	if (!strcmp(ch,"q")||!strcmp(ch,"n")) break;
   }

  /** close device **/
  close(fd);
  return 0;

}

